/*-----------------------------------------------------------------------------
[]	UnicoderFontDlg.cpp
[Tv]	jR[htHgҏW_CAONX̎
[l]	Ȃ
[]	2003-02-25	NC		Rgt(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "shitarabian.h"
#include "UnicoderDlg.h"
#include "UnicodeFontDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/*-----------------------------------------------------------------------------
[]	RXgN^
[@\]	CX^X̐B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
CUnicoderDlg::CUnicoderDlg(CWnd* pParent /*=NULL*/)
	: COwnerTabPage(CUnicoderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnicoderDlg)
	m_bEnable = FALSE;
	//}}AFX_DATA_INIT
}


/*-----------------------------------------------------------------------------
[]	f[^ϊ
[@\]	CDialog::DoDataExchange()̃wvQƁB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnicoderDlg)
	DDX_Control(pDX, IDC_UNICODER_EDIT, m_btnEdit);
	DDX_Control(pDX, IDC_UNICODER_FONTLIST, m_FontList);
	DDX_Control(pDX, IDC_UNICODER_UP, m_btnUp);
	DDX_Control(pDX, IDC_UNICODER_DOWN, m_btnDown);
	DDX_Control(pDX, IDC_UNICODER_DELETE, m_btnDelete);
	DDX_Control(pDX, IDC_UNICODER_ADD, m_btnAdd);
	DDX_Check(pDX, IDC_UNICODER_ENABLE, m_bEnable);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnicoderDlg, CDialog)
	//{{AFX_MSG_MAP(CUnicoderDlg)
	ON_BN_CLICKED(IDC_UNICODER_ADD, OnUnicoderAdd)
	ON_BN_CLICKED(IDC_UNICODER_EDIT, OnUnicoderEdit)
	ON_BN_CLICKED(IDC_UNICODER_DELETE, OnUnicoderDelete)
	ON_BN_CLICKED(IDC_UNICODER_UP, OnUnicoderUp)
	ON_BN_CLICKED(IDC_UNICODER_DOWN, OnUnicoderDown)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_UNICODER_FONTLIST, OnItemchangedUnicoderFontlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/*-----------------------------------------------------------------------------
[]	nh
[@\]	l̐ݒB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL CUnicoderDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Xg̃Jݒ
	m_FontList.InsertColumn(	0,	"tHg"	);
	m_FontList.InsertColumn(	1,	"Jn"	);
	m_FontList.InsertColumn(	2,	"I"	);
	
	m_FontList.SetColumnWidth(	0,	250		);
	m_FontList.SetColumnWidth(	1,	70		);
	m_FontList.SetColumnWidth(	2,	70		);

	// Xgvfǉ
	for( int idxItem=0 ; idxItem<m_FontList.GetList()->GetSize() ; idxItem++ )
	{
		CUnicodeFont&	Font = (*(m_FontList.GetList()))[idxItem];
		m_FontList.InsertItem(
			idxItem,
			Font.m_Font.m_strFontName
		);
	}


//  (3344) BGN 2003.12.20 (moralog) ʐݒ̃jR[hŒǉ̃{^ƋI
// @\𖳌ɂĂ
	VisibleControl();
//  (3146) END

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


/*-----------------------------------------------------------------------------
[]	ǉ{^nh
[@\]	ݒ̒ǉB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::OnUnicoderAdd() 
{
	CUnicodeFont	Font;
	m_FontList.GetList()->Add( Font );

	int idxItem = m_FontList.InsertItem(
		m_FontList.GetItemCount()-1,
		Font.m_Font.m_strFontName
	);

	m_FontList.SetSelectionMark( idxItem-1 );
	m_FontList.SetItemState( idxItem-1, LVIS_SELECTED, LVIS_SELECTED );

	VisibleControl();
}


/*-----------------------------------------------------------------------------
[]	ҏW{^nh
[@\]	IĂݒ̕ҏWB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::OnUnicoderEdit() 
{
	int	idxItem = m_FontList.GetSelectionMark();
	if ( idxItem >= 0 )
	{
		CUnicodeFontDlg	dlg;
		dlg.GetUnicodeFont()->Copy( (*(m_FontList.GetList()))[idxItem] );
		if ( dlg.DoModal() == IDOK )
		{
			(*(m_FontList.GetList())).SetAt(idxItem, *(dlg.GetUnicodeFont()) );
		}
		RedrawWindow();
	}
	VisibleControl();
}


/*-----------------------------------------------------------------------------
[]	폜{^nh
[@\]	IĂݒ̍폜B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::OnUnicoderDelete() 
{
	int	idxItem = m_FontList.GetSelectionMark();
	if ( idxItem >= 0 )
	{
		m_FontList.GetList()->RemoveAt( idxItem );
		m_FontList.DeleteItem( idxItem );

		m_FontList.SetSelectionMark( idxItem-1 );
		m_FontList.SetItemState( idxItem-1, LVIS_SELECTED, LVIS_SELECTED );
	}
	VisibleControl();
}


/*-----------------------------------------------------------------------------
[]	փ{^nh
[@\]	IĂݒ̗DxグB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::OnUnicoderUp() 
{
	int		idxItem = m_FontList.GetSelectionMark();
	if ( idxItem >= 0 )
	{
		// z̏Ԃւ
		CUnicodeFontArray& Itemz = *m_FontList.GetList();
		CUnicodeFont	UnicodeFont = Itemz[idxItem];

		Itemz.RemoveAt( idxItem );
		Itemz.InsertAt( idxItem-1, UnicodeFont );

		m_FontList.DeleteItem( idxItem );
		m_FontList.InsertItem(
			idxItem-1,
			UnicodeFont.m_Font.m_strFontName
		);

		m_FontList.SetSelectionMark( idxItem-1 );
		m_FontList.SetItemState( idxItem-1, LVIS_SELECTED, LVIS_SELECTED );
	}
	VisibleControl();
}


/*-----------------------------------------------------------------------------
[]	փ{^nh
[@\]	IĂݒ̗DxB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::OnUnicoderDown() 
{
	int		idxItem = m_FontList.GetSelectionMark();
	if ( idxItem < m_FontList.GetItemCount()-1 )
	{
		// z̏Ԃւ
		CUnicodeFontArray& Itemz = *m_FontList.GetList();
		CUnicodeFont	UnicodeFont = Itemz[idxItem];

		Itemz.RemoveAt( idxItem );
		Itemz.InsertAt( idxItem+1, UnicodeFont );

		m_FontList.DeleteItem( idxItem );
		m_FontList.InsertItem(
			idxItem+1,
			UnicodeFont.m_Font.m_strFontName
		);

		m_FontList.SetSelectionMark( idxItem+1 );
		m_FontList.SetItemState( idxItem+1, LVIS_SELECTED, LVIS_SELECTED );
	}
	VisibleControl();
}


/*-----------------------------------------------------------------------------
[]	{^Enable
[@\]	{^EnableԂ𐧌䂷B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::VisibleControl()
{
	int		idxItem = m_FontList.GetSelectionMark();

//  (3344) BGN 2003.12.20 (moralog) ʐݒ̃jR[hŒǉ̃{^ƋI
// @\𖳌ɂĂ
	m_btnUp.EnableWindow( FALSE );
	m_btnDown.EnableWindow( FALSE );
	m_btnAdd.EnableWindow( FALSE );
	m_btnEdit.EnableWindow( FALSE );
	m_btnDelete.EnableWindow( FALSE );
/*
//  oridinal BGN
	// փ{^́AւƂɗL
	m_btnUp.EnableWindow( idxItem > 0 );

	// փ{^́AւƂɗL
	m_btnDown.EnableWindow( idxItem < m_FontList.GetItemCount()-1 );

	// ǉ{^͂łL
	m_btnAdd.EnableWindow( TRUE );

	// ҏWE폜{^͑IvfƂɗL
	m_btnEdit.EnableWindow( idxItem > -1 );
	m_btnDelete.EnableWindow( idxItem > -1 );
//  oridinal END
*/
//  (3146) END
}


/*-----------------------------------------------------------------------------
[]	XgIvfύXnh
[@\]	Xg̑IԂύXꂽƂA{^EnableԂ𐧌䂷B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CUnicoderDlg::OnItemchangedUnicoderFontlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// warning C4239:x̖
	pNMHDR;

	VisibleControl();
	*pResult = 0;
}
